#!/bin/bash
# bash simple script to get the varnish 3 hit_ratio
# by Felipe Ferreira Mar/2014

if [ $# -ne 2 ]; then
# set default hit_ratio thresholds
CRIT=5
WARN=1
else
CRIT=$1 
WARN=$2
fi

L="/tmp/backend_fail.log"  #log de antes
LN="/tmp/backend_fail_now.log" #log de agora

function sai(){
	echo $MSG
	/bin/cp -f $LN $L
	exit $E
}

if [ ! -f  $L ];then
	echo "0" > $L
	echo "0" > $LN
	echo "FILE $L NOT FOUND"
fi

/usr/bin/varnishstat -1  -f backend_fail |awk '{ print $2}'>$LN

B=`tail -1 $L`
N=`tail -1 $LN`

if [ "$N" -eq "$B" ]; then
	MSG="OK - No erros found on backend|erros=0"
	E=0
	D=0
	sai
else
	#count diff
	D=`echo $N - $B |bc`
fi

MSG="$D erros on backend|erros=${D}"

if [ "$D" -ge "$CRIT" ]; then
	MSG="CRITICAL - $MSG"
	E=2
	sai
fi
if [ "$D" -ge "$WARN" ]; then
	MSG="WARNING - $MSG"
	E=1
	sai
else
	MSG="OK - $MSG"
	E=0
	sai
fi

