#!/bin/bash
# bash simple script to get the varnish 3 hit_ratio
# by Felipe Ferreira Mar/2014

if [ $# -ne 2 ]; then
# set default hit_ratio thresholds
CRIT=90
WARN=95
else
CRIT=$1 
WARN=$2
fi

function getstat() {
# handles in case it dosent get the result in the first time, tries 3 times
C=0
while [ $C -lt 3 ]
do
R=`/usr/bin/varnishstat -1 -f  client_req,cache_miss`
if [[ "$R" ]];then
#        echo $C
        M=`echo $R |awk '{ print $9}'`
        T=`echo $R |awk '{ print $3}'`
        if [ "$T" ] && [ "$M" ];then
                C=4
        else
#                echo "Some values not found"
                C=`expr $C + 1`
        fi
else
#        echo "Try again: $C"
        R=`/usr/bin/varnishstat -1 -f  client_req,cache_miss`
        C= `expr $C + 1`
fi
done
}

getstat

R1=`perl -e "printf('%.2f',100*${M})"`
R2=`perl -e "printf('%.2f',${R1}/${T})"`
R3=`perl -e "printf('%.2f',100-${R2})"`

MSG="${R3}% hit_ratio|hit_ratio=${R3}"
H=`perl -e "printf('%.0f',${R3})"`
#echo "DEBUG: $H $CRIT $WARN"

if [ "$H" -le "$CRIT" ]; then
	echo "CRITICAL - $MSG"
	exit 2
fi
if [ "$H" -le "$WARN" ]; then
	echo "WARNING - $MSG"
	exit 1
else
	echo "OK - $MSG"
	exit 0
fi
